package main.java;

import java.util.HashMap;
import java.util.Map;

import org.jbpm.api.Execution;
import org.jbpm.api.ProcessInstance;
import org.jbpm.test.JbpmTestCase;


/**
 * @author 
 */
public class ConditionalTest extends JbpmTestCase {
  
  String deploymentId;
  
  protected void setUp() throws Exception {
    super.setUp();
    
    deploymentId = repositoryService.createDeployment()
        .addResourceFromClasspath("CondProc.jpdl.xml")
        .deploy();
  }

  protected void tearDown() throws Exception {
    repositoryService.deleteDeploymentCascade(deploymentId);
    
    super.tearDown();
  }

  public void testDecisionConditionsGood() {
    Map<String, Object> variables = new HashMap<String, Object>();
    variables.put("content", "good");
    ProcessInstance processInstance = executionService.startProcessInstanceByKey("CondProc", variables);

    System.out.println(processInstance.findActiveActivityNames());

    Execution ex = processInstance.findActiveExecutionIn("state1");
      processInstance = executionService.signalExecutionById(ex.getId());
     System.out.println(processInstance.findActiveActivityNames());
     
     ex = processInstance.findActiveExecutionIn("state2");
     processInstance = executionService.signalExecutionById(ex.getId());
    System.out.println(processInstance.findActiveActivityNames());
    

    ex = processInstance.findActiveExecutionIn("state5");
    processInstance = executionService.signalExecutionById(ex.getId());
    
    System.out.println(processInstance.findActiveActivityNames());

    assertActivityActive(processInstance.getId(), "state4");
  }

}
